#include <stdlib.h>
#include <stdio.h>
#include <locale.h>
#include <glib.h>
#include <glib/gprintf.h>

int loop = 100;
GThread *tid;

void critical_func( GMutex *mutex ) {
   g_mutex_lock( mutex );
   // какие-то вычисления ...
   g_printf( "%c", tid == g_thread_self() ? '+' : '-' ); 
   g_mutex_unlock( mutex );
}

gpointer thread_func( gpointer data ) {  // потоковая функция;
   int i;
   for( i = 0; i < loop; i++ )
      critical_func( (GMutex*)data );
   return 0;
}

int main( int argc, char *argv[] ) {
   int i;
   GMutex *mutex = g_mutex_new();
   if( argc > 1 && 0 != atoi( argv[ 1 ] ) ) {
      loop = atoi( argv[ 1 ] );
//    sscanf( argv[ 1 ], "%d", &loop );
   }
   tid = g_thread_new( "thread", thread_func, (gpointer)mutex );
   for( i = 0; i < loop; i++ )
      critical_func( mutex );
   g_thread_join( tid );                 // ожидание завершения потока
   g_printf( "\n" );
   return 0;
}
