#include <locale.h>
#include <glib.h>
#include <glib/gprintf.h>

/* struct _GTimeVal {
  glong tv_sec;
  glong tv_usec;
}; */
static glong interval;

gpointer thread_func( gpointer data ) {     // потоковая функция;
   GTimeVal time;
   g_get_current_time( &time );             // время начала
   g_printf( "начало потока :\t%lu\n", interval = time.tv_sec );
   g_usleep( 1000000 );                     // ожидание 1 сек.
   g_get_current_time( &time );             // время завершения
   g_printf( "конец потока :\t%lu\n", time.tv_sec );
   interval = time.tv_sec - interval;
   return 0;
}

int main( int argc, char *argv[] ) {
   setlocale( LC_ALL, "" );      // по умолчанию, из $LANG
   g_thread_init( NULL );        // инициализация потоков
   GThread *thread_id = g_thread_create( thread_func, NULL, TRUE, NULL ); // создаём поток
   g_thread_join( thread_id );   // ожидание завершения потока
   g_printf( "время ожидание завершения потока = %lu\n", interval ); 
   return 0;
}
